Tag
Hash :
f6cae3ed
Author :
Date :
2020-09-13T14:05:17
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647 648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687 688 689 690 691 692 693 694 695 696 697 698 699 700 701 702 703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718 719 720 721 722 723 724 725 726 727 728 729 730 731 732 733 734 735 736 737 738 739 740 741 742 743 744 745 746 747 748 749 750 751 752 753 754 755 756 757 758 759 760 761 762 763 764 765 766 767 768 769 770 771 772 773 774 775 776 777 778 779 780 781 782 783 784 785 786 787 788 789 790 791
#!/bin/sh
#
# Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
. ./common.sh
test_cherrypick_basic() {
local testroot=`test_init cherrypick_basic`
got checkout $testroot/repo $testroot/wt > /dev/null
ret="$?"
if [ "$ret" != "0" ]; then
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/repo && git checkout -q -b newbranch)
echo "modified delta on branch" > $testroot/repo/gamma/delta
git_commit $testroot/repo -m "committing to delta on newbranch"
echo "modified alpha on branch" > $testroot/repo/alpha
(cd $testroot/repo && git rm -q beta)
echo "new file on branch" > $testroot/repo/epsilon/new
(cd $testroot/repo && git add epsilon/new)
git_commit $testroot/repo -m "committing more changes on newbranch"
local branch_rev=`git_show_head $testroot/repo`
(cd $testroot/wt && got cherrypick $branch_rev > $testroot/stdout)
echo "G alpha" > $testroot/stdout.expected
echo "D beta" >> $testroot/stdout.expected
echo "A epsilon/new" >> $testroot/stdout.expected
echo "Merged commit $branch_rev" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
echo "modified alpha on branch" > $testroot/content.expected
cat $testroot/wt/alpha > $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
if [ -e $testroot/wt/beta ]; then
echo "removed file beta still exists on disk" >&2
test_done "$testroot" "1"
return 1
fi
echo "new file on branch" > $testroot/content.expected
cat $testroot/wt/epsilon/new > $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
echo 'M alpha' > $testroot/stdout.expected
echo 'D beta' >> $testroot/stdout.expected
echo 'A epsilon/new' >> $testroot/stdout.expected
(cd $testroot/wt && got status > $testroot/stdout)
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
fi
test_done "$testroot" "$ret"
}
test_cherrypick_root_commit() {
local testroot=`test_init cherrypick_root_commit`
got checkout $testroot/repo $testroot/wt > /dev/null
ret="$?"
if [ "$ret" != "0" ]; then
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/repo && git checkout -q -b newbranch)
(cd $testroot/repo && git rm -q alpha)
(cd $testroot/repo && git rm -q beta)
(cd $testroot/repo && git rm -q epsilon/zeta)
(cd $testroot/repo && git rm -q gamma/delta)
mkdir -p $testroot/repo/epsilon
echo "new file on branch" > $testroot/repo/epsilon/new
(cd $testroot/repo && git add epsilon/new)
git_commit $testroot/repo -m "committing on newbranch"
echo "modified new file on branch" >> $testroot/repo/epsilon/new
git_commit $testroot/repo -m "committing on newbranch again"
tree=`git_show_tree $testroot/repo`
root_commit=`git_commit_tree $testroot/repo "new root commit" $tree`
(cd $testroot/wt && got cherrypick $root_commit > $testroot/stdout)
echo "A epsilon/new" > $testroot/stdout.expected
echo "Merged commit $root_commit" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
echo "new file on branch" > $testroot/content.expected
echo "modified new file on branch" >> $testroot/content.expected
cat $testroot/wt/epsilon/new > $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
echo 'A epsilon/new' > $testroot/stdout.expected
(cd $testroot/wt && got status > $testroot/stdout)
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
fi
test_done "$testroot" "$ret"
}
test_cherrypick_into_work_tree_with_conflicts() {
local testroot=`test_init cherrypick_into_work_tree_with_conflicts`
got checkout $testroot/repo $testroot/wt > /dev/null
ret="$?"
if [ "$ret" != "0" ]; then
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/repo && git checkout -q -b newbranch)
echo "modified delta on branch" > $testroot/repo/gamma/delta
git_commit $testroot/repo -m "committing to delta on newbranch"
echo "modified alpha on branch" > $testroot/repo/alpha
(cd $testroot/repo && git rm -q beta)
echo "new file on branch" > $testroot/repo/epsilon/new
(cd $testroot/repo && git add epsilon/new)
git_commit $testroot/repo -m "committing more changes on newbranch"
local branch_rev=`git_show_head $testroot/repo`
# fake a merge conflict
echo '<<<<<<<' > $testroot/wt/alpha
echo 'alpha' >> $testroot/wt/alpha
echo '=======' >> $testroot/wt/alpha
echo 'alpha, too' >> $testroot/wt/alpha
echo '>>>>>>>' >> $testroot/wt/alpha
cp $testroot/wt/alpha $testroot/content.expected
echo "C alpha" > $testroot/stdout.expected
(cd $testroot/wt && got status > $testroot/stdout)
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && got cherrypick $branch_rev \
> $testroot/stdout 2> $testroot/stderr)
ret="$?"
if [ "$ret" == "0" ]; then
echo "cherrypick succeeded unexpectedly" >&2
test_done "$testroot" "1"
return 1
fi
echo -n > $testroot/stdout.expected
echo -n "got: work tree contains conflicted files; " \
> $testroot/stderr.expected
echo "these conflicts must be resolved first" \
>> $testroot/stderr.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
cmp -s $testroot/stderr.expected $testroot/stderr
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stderr.expected $testroot/stderr
test_done "$testroot" "$ret"
return 1
fi
cmp -s $testroot/content.expected $testroot/wt/alpha
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/content.expected $testroot/wt/alpha
fi
test_done "$testroot" "$ret"
}
test_cherrypick_modified_submodule() {
local testroot=`test_init cherrypick_modified_submodules`
make_single_file_repo $testroot/repo2 foo
(cd $testroot/repo && git submodule -q add ../repo2)
(cd $testroot/repo && git commit -q -m 'adding submodule')
got checkout $testroot/repo $testroot/wt > /dev/null
echo "modified foo" > $testroot/repo2/foo
(cd $testroot/repo2 && git commit -q -a -m 'modified a submodule')
(cd $testroot/repo && git checkout -q -b newbranch)
# Update the repo/repo2 submodule link on newbranch
(cd $testroot/repo && git -C repo2 pull -q)
(cd $testroot/repo && git add repo2)
git_commit $testroot/repo -m "modified submodule link"
local commit_id=`git_show_head $testroot/repo`
# This cherrypick is a no-op because Got's file index
# does not track submodules.
(cd $testroot/wt && got cherrypick $commit_id > $testroot/stdout)
echo -n > $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
fi
test_done "$testroot" "$ret"
}
test_cherrypick_added_submodule() {
local testroot=`test_init cherrypick_added_submodules`
got checkout $testroot/repo $testroot/wt > /dev/null
make_single_file_repo $testroot/repo2 foo
# Add the repo/repo2 submodule on newbranch
(cd $testroot/repo && git checkout -q -b newbranch)
(cd $testroot/repo && git submodule -q add ../repo2)
(cd $testroot/repo && git commit -q -m 'adding submodule')
local commit_id=`git_show_head $testroot/repo`
(cd $testroot/wt && got cherrypick $commit_id > $testroot/stdout)
echo "A .gitmodules" > $testroot/stdout.expected
echo "Merged commit $commit_id" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
fi
test_done "$testroot" "$ret"
}
test_cherrypick_conflict_wt_file_vs_repo_submodule() {
local testroot=`test_init cherrypick_conflict_wt_file_vs_repo_submodule`
got checkout $testroot/repo $testroot/wt > /dev/null
# Add a file which will clash with the submodule
echo "This is a file called repo2" > $testroot/wt/repo2
(cd $testroot/wt && got add repo2 > /dev/null)
(cd $testroot/wt && got commit -m 'add file repo2' > /dev/null)
ret="$?"
if [ "$ret" != "0" ]; then
echo "commit failed unexpectedly" >&2
test_done "$testroot" "1"
return 1
fi
make_single_file_repo $testroot/repo2 foo
# Add the repo/repo2 submodule on newbranch
(cd $testroot/repo && git checkout -q -b newbranch)
(cd $testroot/repo && git submodule -q add ../repo2)
(cd $testroot/repo && git commit -q -m 'adding submodule')
local commit_id=`git_show_head $testroot/repo`
# Modify the clashing file such that any modifications brought
# in by 'got cherrypick' would require a merge.
echo "This file was changed" > $testroot/wt/repo2
(cd $testroot/wt && got update >/dev/null)
(cd $testroot/wt && got cherrypick $commit_id > $testroot/stdout)
echo "A .gitmodules" > $testroot/stdout.expected
echo "Merged commit $commit_id" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && got status > $testroot/stdout)
echo "A .gitmodules" > $testroot/stdout.expected
echo "M repo2" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
fi
test_done "$testroot" "$ret"
}
test_cherrypick_modified_symlinks() {
local testroot=`test_init cherrypick_modified_symlinks`
(cd $testroot/repo && ln -s alpha alpha.link)
(cd $testroot/repo && ln -s epsilon epsilon.link)
(cd $testroot/repo && ln -s /etc/passwd passwd.link)
(cd $testroot/repo && ln -s ../beta epsilon/beta.link)
(cd $testroot/repo && ln -s nonexistent nonexistent.link)
(cd $testroot/repo && git add .)
git_commit $testroot/repo -m "add symlinks"
local commit_id1=`git_show_head $testroot/repo`
got branch -r $testroot/repo foo
got checkout -b foo $testroot/repo $testroot/wt > /dev/null
(cd $testroot/repo && ln -sf beta alpha.link)
(cd $testroot/repo && ln -sfh gamma epsilon.link)
(cd $testroot/repo && ln -sf ../gamma/delta epsilon/beta.link)
(cd $testroot/repo && ln -sf .got/bar $testroot/repo/dotgotfoo.link)
(cd $testroot/repo && git rm -q nonexistent.link)
(cd $testroot/repo && ln -sf epsilon/zeta zeta.link)
(cd $testroot/repo && git add .)
git_commit $testroot/repo -m "change symlinks"
local commit_id2=`git_show_head $testroot/repo`
(cd $testroot/wt && got cherrypick $commit_id2 > $testroot/stdout)
echo "G alpha.link" > $testroot/stdout.expected
echo "G epsilon/beta.link" >> $testroot/stdout.expected
echo "A dotgotfoo.link" >> $testroot/stdout.expected
echo "G epsilon.link" >> $testroot/stdout.expected
echo "D nonexistent.link" >> $testroot/stdout.expected
echo "A zeta.link" >> $testroot/stdout.expected
echo "Merged commit $commit_id2" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
if ! [ -h $testroot/wt/alpha.link ]; then
echo "alpha.link is not a symlink"
test_done "$testroot" "1"
return 1
fi
readlink $testroot/wt/alpha.link > $testroot/stdout
echo "beta" > $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
if ! [ -h $testroot/wt/epsilon.link ]; then
echo "epsilon.link is not a symlink"
test_done "$testroot" "1"
return 1
fi
readlink $testroot/wt/epsilon.link > $testroot/stdout
echo "gamma" > $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
if [ -h $testroot/wt/passwd.link ]; then
echo -n "passwd.link symlink points outside of work tree: " >&2
readlink $testroot/wt/passwd.link >&2
test_done "$testroot" "1"
return 1
fi
echo -n "/etc/passwd" > $testroot/content.expected
cp $testroot/wt/passwd.link $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
readlink $testroot/wt/epsilon/beta.link > $testroot/stdout
echo "../gamma/delta" > $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
if [ -h $testroot/wt/nonexistent.link ]; then
echo -n "nonexistent.link still exists on disk: " >&2
readlink $testroot/wt/nonexistent.link >&2
test_done "$testroot" "1"
return 1
fi
test_done "$testroot" "0"
}
test_cherrypick_symlink_conflicts() {
local testroot=`test_init cherrypick_symlink_conflicts`
(cd $testroot/repo && ln -s alpha alpha.link)
(cd $testroot/repo && ln -s epsilon epsilon.link)
(cd $testroot/repo && ln -s /etc/passwd passwd.link)
(cd $testroot/repo && ln -s ../beta epsilon/beta.link)
(cd $testroot/repo && ln -s nonexistent nonexistent.link)
(cd $testroot/repo && ln -sf epsilon/zeta zeta.link)
(cd $testroot/repo && git add .)
git_commit $testroot/repo -m "add symlinks"
local commit_id1=`git_show_head $testroot/repo`
(cd $testroot/repo && ln -sf beta alpha.link)
(cd $testroot/repo && ln -sf beta boo.link)
(cd $testroot/repo && ln -sfh gamma epsilon.link)
(cd $testroot/repo && ln -sf ../gamma/delta epsilon/beta.link)
echo 'this is regular file foo' > $testroot/repo/dotgotfoo.link
(cd $testroot/repo && ln -sf .got/bar dotgotbar.link)
(cd $testroot/repo && git rm -q nonexistent.link)
(cd $testroot/repo && ln -sf gamma/delta zeta.link)
(cd $testroot/repo && ln -sf alpha new.link)
(cd $testroot/repo && git add .)
git_commit $testroot/repo -m "change symlinks"
local commit_id2=`git_show_head $testroot/repo`
got branch -r $testroot/repo -c $commit_id1 foo
got checkout -b foo $testroot/repo $testroot/wt > /dev/null
# modified symlink to file A vs modified symlink to file B
(cd $testroot/wt && ln -sf gamma/delta alpha.link)
# modified symlink to dir A vs modified symlink to file B
(cd $testroot/wt && ln -sfh beta epsilon.link)
# modeified symlink to file A vs modified symlink to dir B
(cd $testroot/wt && ln -sfh ../gamma epsilon/beta.link)
# added regular file A vs added bad symlink to file A
(cd $testroot/wt && ln -sf .got/bar dotgotfoo.link)
(cd $testroot/wt && got add dotgotfoo.link > /dev/null)
# added bad symlink to file A vs added regular file A
echo 'this is regular file bar' > $testroot/wt/dotgotbar.link
(cd $testroot/wt && got add dotgotbar.link > /dev/null)
# added symlink to file A vs unversioned file A
echo 'this is unversioned file boo' > $testroot/wt/boo.link
# removed symlink to non-existent file A vs modified symlink
# to nonexistent file B
(cd $testroot/wt && ln -sf nonexistent2 nonexistent.link)
# modified symlink to file A vs removed symlink to file A
(cd $testroot/wt && got rm zeta.link > /dev/null)
# added symlink to file A vs added symlink to file B
(cd $testroot/wt && ln -sf beta new.link)
(cd $testroot/wt && got add new.link > /dev/null)
(cd $testroot/wt && got commit -S -m "change symlinks on foo" \
> /dev/null)
(cd $testroot/wt && got update >/dev/null)
(cd $testroot/wt && got cherrypick $commit_id2 > $testroot/stdout)
echo -n > $testroot/stdout.expected
echo "C alpha.link" >> $testroot/stdout.expected
echo "C epsilon/beta.link" >> $testroot/stdout.expected
echo "? boo.link" >> $testroot/stdout.expected
echo "C epsilon.link" >> $testroot/stdout.expected
echo "C dotgotbar.link" >> $testroot/stdout.expected
echo "C dotgotfoo.link" >> $testroot/stdout.expected
echo "D nonexistent.link" >> $testroot/stdout.expected
echo "! zeta.link" >> $testroot/stdout.expected
echo "C new.link" >> $testroot/stdout.expected
echo "Merged commit $commit_id2" >> $testroot/stdout.expected
echo "Files with new merge conflicts: 6" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
if [ -h $testroot/wt/alpha.link ]; then
echo "alpha.link is a symlink"
test_done "$testroot" "1"
return 1
fi
echo "<<<<<<< merged change: commit $commit_id2" \
> $testroot/content.expected
echo "beta" >> $testroot/content.expected
echo "3-way merge base: commit $commit_id1" \
>> $testroot/content.expected
echo "alpha" >> $testroot/content.expected
echo "=======" >> $testroot/content.expected
echo "gamma/delta" >> $testroot/content.expected
echo '>>>>>>>' >> $testroot/content.expected
echo -n "" >> $testroot/content.expected
cp $testroot/wt/alpha.link $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
if [ -h $testroot/wt/boo.link ]; then
echo "boo.link is a symlink"
test_done "$testroot" "1"
return 1
fi
echo "this is unversioned file boo" > $testroot/content.expected
cp $testroot/wt/boo.link $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
if [ -h $testroot/wt/epsilon.link ]; then
echo "epsilon.link is a symlink"
test_done "$testroot" "1"
return 1
fi
echo "<<<<<<< merged change: commit $commit_id2" \
> $testroot/content.expected
echo "gamma" >> $testroot/content.expected
echo "3-way merge base: commit $commit_id1" \
>> $testroot/content.expected
echo "epsilon" >> $testroot/content.expected
echo "=======" >> $testroot/content.expected
echo "beta" >> $testroot/content.expected
echo '>>>>>>>' >> $testroot/content.expected
echo -n "" >> $testroot/content.expected
cp $testroot/wt/epsilon.link $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
if [ -h $testroot/wt/passwd.link ]; then
echo -n "passwd.link symlink points outside of work tree: " >&2
readlink $testroot/wt/passwd.link >&2
test_done "$testroot" "1"
return 1
fi
echo -n "/etc/passwd" > $testroot/content.expected
cp $testroot/wt/passwd.link $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
if [ -h $testroot/wt/epsilon/beta.link ]; then
echo "epsilon/beta.link is a symlink"
test_done "$testroot" "1"
return 1
fi
echo "<<<<<<< merged change: commit $commit_id2" \
> $testroot/content.expected
echo "../gamma/delta" >> $testroot/content.expected
echo "3-way merge base: commit $commit_id1" \
>> $testroot/content.expected
echo "../beta" >> $testroot/content.expected
echo "=======" >> $testroot/content.expected
echo "../gamma" >> $testroot/content.expected
echo '>>>>>>>' >> $testroot/content.expected
echo -n "" >> $testroot/content.expected
cp $testroot/wt/epsilon/beta.link $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
if [ -h $testroot/wt/nonexistent.link ]; then
echo -n "nonexistent.link still exists on disk: " >&2
readlink $testroot/wt/nonexistent.link >&2
test_done "$testroot" "1"
return 1
fi
if [ -h $testroot/wt/dotgotfoo.link ]; then
echo "dotgotfoo.link is a symlink"
test_done "$testroot" "1"
return 1
fi
echo "<<<<<<< merged change: commit $commit_id2" \
> $testroot/content.expected
echo "this is regular file foo" >> $testroot/content.expected
echo "=======" >> $testroot/content.expected
echo -n ".got/bar" >> $testroot/content.expected
echo '>>>>>>>' >> $testroot/content.expected
cp $testroot/wt/dotgotfoo.link $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
if [ -h $testroot/wt/dotgotbar.link ]; then
echo "dotgotbar.link is a symlink"
test_done "$testroot" "1"
return 1
fi
echo "<<<<<<< merged change: commit $commit_id2" \
> $testroot/content.expected
echo -n ".got/bar" >> $testroot/content.expected
echo "=======" >> $testroot/content.expected
echo "this is regular file bar" >> $testroot/content.expected
echo '>>>>>>>' >> $testroot/content.expected
echo -n "" >> $testroot/content.expected
cp $testroot/wt/dotgotbar.link $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
if [ -h $testroot/wt/new.link ]; then
echo "new.link is a symlink"
test_done "$testroot" "1"
return 1
fi
echo "<<<<<<< merged change: commit $commit_id2" \
> $testroot/content.expected
echo "alpha" >> $testroot/content.expected
echo "=======" >> $testroot/content.expected
echo "beta" >> $testroot/content.expected
echo '>>>>>>>' >> $testroot/content.expected
echo -n "" >> $testroot/content.expected
cp $testroot/wt/new.link $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
echo "A dotgotfoo.link" > $testroot/stdout.expected
echo "M new.link" >> $testroot/stdout.expected
echo "D nonexistent.link" >> $testroot/stdout.expected
(cd $testroot/wt && got status > $testroot/stdout)
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
test_done "$testroot" "0"
}
test_cherrypick_with_path_prefix_and_empty_tree() {
local testroot=`test_init cherrypick_with_path_prefix_and_empty_tree 1`
(cd $testroot/repo && git commit --allow-empty \
-m "initial empty commit" >/dev/null)
(cd $testroot/repo && got br bar >/dev/null)
mkdir -p $testroot/repo/epsilon
echo "file foo" > $testroot/repo/epsilon/foo
(cd $testroot/repo && git add .)
git_commit $testroot/repo -m "add file foo"
local commit_id=`git_show_head $testroot/repo`
got checkout -b bar $testroot/repo $testroot/wt > /dev/null
ret="$?"
if [ "$ret" != "0" ]; then
echo "got checkout failed unexpectedly" >&2
test_done "$testroot" "$ret"
return 1
fi
mkdir -p $testroot/wt/epsilon
echo "new file" > $testroot/wt/epsilon/new
(cd $testroot/wt && got add epsilon/new >/dev/null)
(cd $testroot/wt && got commit -m "add file on branch bar" > /dev/null)
got checkout -b bar -p epsilon $testroot/repo $testroot/wt2 > /dev/null
ret="$?"
if [ "$ret" != "0" ]; then
echo "got checkout failed unexpectedly" >&2
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt2 && got cherrypick $commit_id > $testroot/stdout)
echo "A foo" > $testroot/stdout.expected
echo "Merged commit $commit_id" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret="$?"
if [ "$ret" != "0" ]; then
diff -u $testroot/stdout.expected $testroot/stdout
fi
test_done "$testroot" "$ret"
}
test_parseargs "$@"
run_test test_cherrypick_basic
run_test test_cherrypick_root_commit
run_test test_cherrypick_into_work_tree_with_conflicts
run_test test_cherrypick_modified_submodule
run_test test_cherrypick_added_submodule
run_test test_cherrypick_conflict_wt_file_vs_repo_submodule
run_test test_cherrypick_modified_symlinks
run_test test_cherrypick_symlink_conflicts
run_test test_cherrypick_with_path_prefix_and_empty_tree